﻿using Syncfusion.SfChart.XForms;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace SimpleSample
{
    public class ChartSample : ContentPage
    {
        public ChartSample()
        {
            var stack = new StackLayout();            
            var button = new Button();
            button.Clicked += button_Clicked;
            button.Text = "Export as PDF";
            stack.Children.Add(button);
            stack.Children.Add(GetChart());
            Content = stack;
        }

        void button_Clicked(object sender, EventArgs e)
        {
            var stream = chart.GetStream();
            DependencyService.Get<IChartDependencyService>().SaveAsPDF("SfChart.pdf", stream);
        }

        private SfChart chart;
        private SfChart GetChart()
        {
            chart = new SfChart
            {
                VerticalOptions = LayoutOptions.FillAndExpand,
                PrimaryAxis = new CategoryAxis { LabelPlacement = LabelPlacement.BetweenTicks },
                SecondaryAxis = new NumericalAxis()
            };

            chart.Series.Add(new ColumnSeries
            {
                DataMarker = new ChartDataMarker(),
                ItemsSource = GetDataPoints(),
                DataMarkerPosition = DataMarkerPosition.Center,
            });
            return chart;
        }

        private static List<ChartDataPoint> GetDataPoints()
        {
            return new List<ChartDataPoint>
            {
                new ChartDataPoint("A", 45),
                new ChartDataPoint("B", 54),
                new ChartDataPoint("C", 65),
                new ChartDataPoint("D", 23),
                new ChartDataPoint("E", 55),
            };
        }
    }
}
